// ============================================================================
// Hamster, a free news- and mailserver for personal, family and workgroup use.
// Copyright (c) 1998-2003, Juergen Haible (<juergen.haible@t-online.de>).
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
// IN THE SOFTWARE.
// ============================================================================

program HControl;

{$INCLUDE Compiler.inc}

uses
  Forms,
  Windows,
  uMD5 in 'lib\uMD5.pas',
  uSHA1 in 'lib\uSHA1.pas',
  uSASL in 'lib\uSASL.pas',
  cPCRE in 'lib\cPCRE.pas',
  uPCRE in 'lib\uPCRE.pas',
  uCRC32 in 'lib\uCRC32.pas',
  uTools in 'lib\uTools.pas',
  uUnicoding in 'lib\uUnicoding.pas',
  uCharMaps8 in 'lib\uCharMaps8.pas',
  uCharsetsU in 'lib\uCharsetsU.pas',
  uCharsets8 in 'lib\uCharsets8.pas',
  uCharsetsW in 'lib\uCharsetsW.pas',
  uCharsets in 'lib\uCharsets.pas',
  uEncoding in 'lib\uEncoding.pas',
  uBlowfish in 'lib\uBlowfish.pas',
  uDateTime in 'lib\uDateTime.pas',
  cLogFile in 'lib\cLogFile.pas',
  cSyncObjects in 'lib\cSyncObjects.pas',
  hh in 'lib\hh.pas',
  hh_funcs in 'lib\hh_funcs.pas',
  uType in 'common\uType.pas',
  uConst in 'common\uConst.pas',
  uConstVar in 'common\uConstVar.pas',
  cLiveMsg in 'common\cLiveMsg.pas',
  cLiveQueue in 'common\cLiveQueue.pas',
  cSettings in 'common\cSettings.pas',
  cSettingsDef in 'common\cSettingsDef.pas',
  uGlobal in 'HControl\uGlobal.pas',
  cClientReCo in 'HControl\cClientReCo.pas',
  cLiveConnector in 'HControl\cLiveConnector.pas',
  cSettingsHdlLive in 'HControl\cSettingsHdlLive.pas',
  fMain in 'HControl\fMain.pas' {frmMain},
  fConnect in 'HControl\fConnect.pas' {frmConnect},
  fSettings in 'HControl\fSettings.pas' {frmSettings},
  fGroupPull in 'HControl\fGroupPull.pas' {frmGroupPull},
  dInput in 'HControl\dInput.pas' {InputDlg},
  fConfApp in 'HControl\fConfApp.pas' {frmConfApp},
  fConfHam in 'HControl\fConfHam.pas' {frmConfHam},
  fConfSrv in 'HControl\fConfSrv.pas' {frmConfSrv},
  fConfGrp in 'HControl\fConfGrp.pas' {frmConfGrp},
  fConfPwd in 'HControl\fConfPwd.pas' {frmConfPwd},
  fConfAcc in 'HControl\fConfAcc.pas' {frmConfAcc},
  fConfFile in 'HControl\fConfFile.pas' {frmConfFile},
  fStartTasks in 'HControl\fStartTasks.pas' {frmStartTasks},
  dDialogs in 'HControl\dDialogs.pas',
  fConfML in 'HControl\fConfML.pas' {frmConfML},
  fConfMailTrap in 'HControl\fConfMailTrap.pas' {frmConfMailTrap},
  cTraps in 'common\cTraps.pas',
  fConfMailTrapTest in 'HControl\fConfMailTrapTest.pas' {frmConfMailTrapTest},
  cArticle in 'common\cArticle.pas',
  fReports in 'HControl\fReports.pas' {frmReports},
  cUserTasks in 'common\cUserTasks.pas',
  fUserTasks in 'HControl\fUserTasks.pas' {frmUserTasks},
  fActions in 'HControl\fActions.pas' {frmActions},
  fScheduler in 'HControl\fScheduler.pas' {frmScheduler},
  cSchedulerCommon in 'common\cSchedulerCommon.pas',
  cHscAction in 'common\cHscAction.pas',
  uWinSvc in 'lib\uWinSvc.pas',
  fService in 'HControl\fService.pas' {frmService},
  fLogFind in 'HControl\fLogFind.pas' {frmLogFind};

{$R *.RES}

begin
  Application.Initialize;
  Application.Title := 'Hamster Control';
  Application.HelpFile := '';
  Application.CreateForm(TfrmMain, frmMain);
  Application.Run;
end.
